using System;
using System.Text;
using System.Runtime.InteropServices;

namespace PrintPreviewer
{
    public class IniFile
    {
        public string m_sIniFileName;

        [DllImport("kernel32")]
        private static extern long WritePrivateProfileString(string section, string key, string val, string filePath);
        [DllImport("kernel32")]
        private static extern int GetPrivateProfileString(string section, string key, string def, StringBuilder retVal, int size, string filePath);

        public IniFile(string sIniFileName)
        {
            SetFileName(sIniFileName); 
        }

        public bool SetFileName(string sIniFileName)
        {
            m_sIniFileName = sIniFileName;
            
            if (m_sIniFileName != String.Empty)
            {
                // Remove double quotes if any
                m_sIniFileName.Remove('\"');

                // Check the file
                if (System.IO.File.Exists(m_sIniFileName))
                {
                    // Replace the file name with its absolute path
                    //m_sIniFileName = status.m_szFullName;
                    return true;
                }
            }
            return false;
        }

        public void IniWriteValue(string Section, string Key, string Value)
        { WritePrivateProfileString(Section, Key, Value, this.m_sIniFileName); }

        public string IniReadValue(string Section, string Key, string Default)
        {
            StringBuilder temp = new StringBuilder(255);
            int i = GetPrivateProfileString(Section, Key, "", temp, 1024, this.m_sIniFileName);
            return (temp.Length > 0) ? temp.ToString() : Default;
        }
    }
}
